stress2: Added reagression tests

PR:	165392
This commit is contained in:
Peter Holm 2022-06-25 08:21:30 +02:00
parent eeb46578c2
commit 25a1b1f30c
5 changed files with 498 additions and 0 deletions

View File

@ -0,0 +1,96 @@
#!/bin/sh
#
# SPDX-License-Identifier: BSD-2-Clause-FreeBSD
#
# Copyright (c) 2022 Peter Holm <pho@FreeBSD.org>
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
# notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
# notice, this list of conditions and the following disclaimer in the
# documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# Regression test for:
# D35514 UFS: make mkdir() reliable when using SU and reaching nlink limit
# Bug 165392 - [ufs] [patch] Multiple mkdir/rmdir fails with errno 31
. ../default.cfg
cat > /tmp/nlink.c <<EOF
#include <sys/stat.h>
#include <ufs/ufs/dinode.h>
#include <err.h>
#include <errno.h>
#include <stdio.h>
#include <unistd.h>
int
main (void) {
int i, mx;
char dir[100];
mx = UFS_LINK_MAX - 2;
for (i = 0; i < mx; i++) {
snprintf(dir, sizeof(dir), "%d", i);
if (mkdir(dir, 0700) == -1)
err(1, "mkdir(%s)", dir);
}
/* The following mkdir(2) must fail */
i = mx;
snprintf(dir, sizeof(dir), "%d", i);
if (mkdir(dir, 0700) != -1) /* this must fail */
err(1, "mkdir(%s)", dir);
if (errno != EMLINK)
err(1, "Must fail: mkdir(%s)", dir);
/* Must succeed */
i = 0;
snprintf(dir, sizeof(dir), "%d", i);
if (rmdir(dir) == -1)
err(1, "rmdir(%s)", dir);
snprintf(dir, sizeof(dir), "%s", "a");
if (mkdir(dir, 0700) == -1)
err(1, "mkdir(%s)", dir);
return (0);
}
EOF
mycc -o /tmp/nlink -Wall -Wextra -O2 /tmp/nlink.c || exit 1
rm /tmp/nlink.c
set -e
here=`pwd`
mount | grep -q "on $mntpoint " && umount -f $mntpoint
mdconfig -l | grep "md$mdstart " && mdconfig -d -u $mdstart
mdconfig -a -t swap -s 1g -u $mdstart
newfs -Un /dev/md$mdstart > /dev/null
mount /dev/md$mdstart $mntpoint
set +e
cd $mntpoint
/tmp/nlink; s=$?
n=`ls -a | wc -l`
[ $s -ne 0 ] && echo "$n dirs"
cd $here
umount $mntpoint
mdconfig -d -u $mdstart
rm /tmp/nlink
exit $s

View File

@ -0,0 +1,71 @@
#!/bin/sh
#
# SPDX-License-Identifier: BSD-2-Clause-FreeBSD
#
# Copyright (c) 2022 Peter Holm <pho@FreeBSD.org>
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
# notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
# notice, this list of conditions and the following disclaimer in the
# documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# Simple test to demonstrate EMLINK issue on a SU file system.
# mkdir: /mnt10/a994: Too many links
[ `id -u ` -ne 0 ] && echo "Must be root!" && exit 1
. ../default.cfg
echo "$newfs_flags" | grep -q U || exit 0
log=/tmp/nlink2.sh.log
md=$mdstart
mp=/mnt$md
mkdir -p $mp
set -e
mount | grep -q "on $mp " && umount -f $mp
mdconfig -l | grep -q md$md && mdconfig -d -u $md
mdconfig -a -t swap -s 1g -u $md
newfs $newfs_flags -n md$md > /dev/null
mount /dev/md$md $mp
set +e
start=`date +%s`
for i in `jot 1000`; do
jot 1000 | xargs -P0 -I% mkdir $mp/a% || { s=1; break; }
jot 1000 | xargs -P0 -I% rmdir $mp/a%
t=$((`date +%s` - start))
if [ $t -ge 300 ]; then
echo "Warn: Timed out in loop #$i after $t seconds"
break
fi
done
if [ $s ]; then
echo "Failed in loop #$i"
df -i $mp
fi
umount $mp
fsck_ffs -fy /dev/md$md > $log 2>&1
grep -Eq "WAS MODIFIED" $log && { s=$((s + 2)); cat $log; }
mdconfig -d -u $md
rm -f $log
exit $s

106
tools/test/stress2/misc/nlink3.sh Executable file
View File

@ -0,0 +1,106 @@
#!/bin/sh
#
# SPDX-License-Identifier: BSD-2-Clause-FreeBSD
#
# Copyright (c) 2022 Peter Holm <pho@FreeBSD.org>
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
# notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
# notice, this list of conditions and the following disclaimer in the
# documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# https://reviews.freebsd.org/D35514
# link() version
. ../default.cfg
cat > /tmp/nlink3.c <<EOF
#include <sys/stat.h>
#include <ufs/ufs/dinode.h>
#include <err.h>
#include <errno.h>
#include <fcntl.h>
#include <stdio.h>
#include <unistd.h>
int
main (void) {
int fd, i, mx;
char file[100];
snprintf(file, sizeof(file), "f");
if ((fd = open(file, O_RDWR | O_CREAT | O_TRUNC,
DEFFILEMODE)) == -1)
err(1, "creat(%s)", file);
close(fd);
mx = UFS_LINK_MAX - 1; /* UFS_LINK_MAX = 32767 */
for (i = 0; i < mx; i++) {
snprintf(file, sizeof(file), "%d", i);
if (link("f", file) == -1)
err(1, "link(%s, %s)", "f", file);
}
/* The following link(2) must fail */
i = mx;
snprintf(file, sizeof(file), "%d", i);
if (link("f", file) != -1)
err(1, "link(%s, %s)", "f", file);
if (errno != EMLINK)
err(1, "Must fail: link(%s, %s)", "f", file);
i = 0;
snprintf(file, sizeof(file), "%d", i);
if (unlink(file) == -1)
err(1, "unlink(%s)", file);
/* Must succeed */
i = mx;
snprintf(file, sizeof(file), "%d", i);
if (link("f", file) == -1)
err(1, "link(%s, %s)", "f", file);
return (0);
}
EOF
mycc -o /tmp/nlink3 -Wall -Wextra -O2 /tmp/nlink3.c || exit 1
rm /tmp/nlink3.c
set -e
here=`pwd`
mount | grep -q "on $mntpoint " && umount -f $mntpoint
mdconfig -l | grep "md$mdstart " && mdconfig -d -u $mdstart
mdconfig -a -t swap -s 1g -u $mdstart
newfs -Un /dev/md$mdstart > /dev/null
mount /dev/md$mdstart $mntpoint
set +e
cd $mntpoint
/tmp/nlink3; s=$?
n=`ls -a | wc -l`
[ $s -ne 0 ] && echo "$n files"
cd $here
umount $mntpoint
mdconfig -d -u $mdstart
rm /tmp/nlink3
exit $s

105
tools/test/stress2/misc/nlink4.sh Executable file
View File

@ -0,0 +1,105 @@
#!/bin/sh
#
# SPDX-License-Identifier: BSD-2-Clause-FreeBSD
#
# Copyright (c) 2022 Peter Holm <pho@FreeBSD.org>
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
# notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
# notice, this list of conditions and the following disclaimer in the
# documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# https://reviews.freebsd.org/D35514
# rename(2) version
. ../default.cfg
cat > /tmp/nlink4.c <<EOF
#include <sys/stat.h>
#include <ufs/ufs/dinode.h>
#include <err.h>
#include <errno.h>
#include <fcntl.h>
#include <stdio.h>
#include <unistd.h>
int
main (void) {
int fd, i, mx;
char file[100];
snprintf(file, sizeof(file), "f");
if ((fd = open(file, O_RDWR | O_CREAT | O_TRUNC,
DEFFILEMODE)) == -1)
err(1, "creat(%s)", file);
close(fd);
mx = UFS_LINK_MAX - 1; /* UFS_LINK_MAX = 32767 */
for (i = 0; i < mx; i++) {
snprintf(file, sizeof(file), "%d", i);
if (link("f", file) == -1)
err(1, "link(%s, %s)", "f", file);
}
/* The following link(2) must fail */
i = mx;
snprintf(file, sizeof(file), "%d", i);
if (link("f", file) != -1)
err(1, "link(%s, %s)", "f", file);
if (errno != EMLINK)
err(1, "Must fail: link(%s, %s)", "f", file);
/* Must succeed */
i = 0;
snprintf(file, sizeof(file), "%d", i);
if (unlink(file) == -1)
err(1, "unlink(%s)", file);
if (rename("1", "a") == -1) {
if (errno == EMLINK)
fprintf(stderr, "Unexpected EMLINK\n");
err(1, "rename(%s, %s)", "1", "a");
}
return (0);
}
EOF
mycc -o /tmp/nlink4 -Wall -Wextra -O2 /tmp/nlink4.c || exit 1
rm /tmp/nlink4.c
set -e
here=`pwd`
mount | grep -q "on $mntpoint " && umount -f $mntpoint
mdconfig -l | grep "md$mdstart " && mdconfig -d -u $mdstart
mdconfig -a -t swap -s 1g -u $mdstart
newfs -Un /dev/md$mdstart > /dev/null
mount /dev/md$mdstart $mntpoint
set +e
cd $mntpoint
/tmp/nlink4; s=$?
n=`ls -a | wc -l`
[ $s -ne 0 ] && echo "$n files"
cd $here
umount $mntpoint
mdconfig -d -u $mdstart
rm /tmp/nlink4
exit $s

120
tools/test/stress2/misc/nlink5.sh Executable file
View File

@ -0,0 +1,120 @@
#!/bin/sh
#
# SPDX-License-Identifier: BSD-2-Clause-FreeBSD
#
# Copyright (c) 2022 Peter Holm <pho@FreeBSD.org>
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
# notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
# notice, this list of conditions and the following disclaimer in the
# documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# https://reviews.freebsd.org/D35514
# Rename dir a/b to c/d
# Test scenario suggestion by kib
. ../default.cfg
cat > /tmp/nlink5.c <<EOF
#include <sys/stat.h>
#include <ufs/ufs/dinode.h>
#include <err.h>
#include <errno.h>
#include <stdio.h>
#include <unistd.h>
int
main (void) {
int i, mx;
char dir[100];
mx = UFS_LINK_MAX - 2; /* UFS_LINK_MAX = 32767 */
for (i = 0; i < mx; i++) {
snprintf(dir, sizeof(dir), "%d", i);
if (mkdir(dir, 0700) == -1)
err(1, "mkdir(%s)", dir);
}
/* The following mkdir(2) must fail */
i = mx;
snprintf(dir, sizeof(dir), "%d", i);
if (mkdir(dir, 0700) != -1) /* this must fail */
err(1, "mkdir(%s)", dir);
if (errno != EMLINK)
err(1, "Must fail: mkdir(%s)", dir);
/* Must succeed */
i = 0;
snprintf(dir, sizeof(dir), "%d", i);
if (rmdir(dir) == -1)
err(1, "rmdir(%s)", dir);
snprintf(dir, sizeof(dir), "%s", "x");
if (mkdir(dir, 0700) == -1)
err(1, "mkdir(%s)", dir);
/* Make room for two top level directories */
if (rmdir("1") == -1)
err(1, "rmdir(1)");
if (rmdir("2") == -1)
err(1, "rmdir(2)");
/* mkdir a c */
snprintf(dir, sizeof(dir), "%s", "a");
if (mkdir(dir, 0700) == -1)
err(1, "mkdir(%s)", dir);
snprintf(dir, sizeof(dir), "%s", "c");
if (mkdir(dir, 0700) == -1)
err(1, "mkdir(%s)", dir);
/* mkdir a/b */
snprintf(dir, sizeof(dir), "%s/%s", "a", "b");
if (mkdir(dir, 0700) == -1)
err(1, "mkdir(%s)", dir);
/* mv a/b c/d */
if (rename("a/b", "c/d") == -1)
err(1, "rename(a/b, c/d)");
return (0);
}
EOF
mycc -o /tmp/nlink5 -Wall -Wextra -O2 /tmp/nlink5.c || exit 1
rm /tmp/nlink5.c
set -e
here=`pwd`
mount | grep -q "on $mntpoint " && umount -f $mntpoint
mdconfig -l | grep "md$mdstart " && mdconfig -d -u $mdstart
mdconfig -a -t swap -s 1g -u $mdstart
newfs -Un /dev/md$mdstart > /dev/null
mount /dev/md$mdstart $mntpoint
set +e
cd $mntpoint
/tmp/nlink5; s=$?
n=`find . -type d -maxdepth 1 | wc -l`
[ $n -ne 32766 ] && s=2
cd $here
umount $mntpoint
mdconfig -d -u $mdstart
rm /tmp/nlink5
exit $s